Syncfusion AI Assistant

How can I help you?

Enable or disable text selection in React PDF Viewer

23 Mar 20266 minutes to read

This guide explains how to enable or disable text selection in the Syncfusion React PDF Viewer using both initialization-time settings and runtime toggling.

Outcome: By the end of this guide, you will be able to control whether users can select text in the PDF Viewer.

Steps to toggle text selection

1. Disable text selection at initialization

Follow one of these steps to disable text selection when the viewer first loads:

Remove the text selection module

Remove the TextSelection module in the services array to disable text selection during initialization.

  • TS
  • <PdfViewerComponent
        id="PdfViewer"
        ref={viewerRef}
        documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
        resourceUrl="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2-pdfviewer-lib"
        style={{ height: '100%' }}
    >
        <Inject
            services={[
                Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView,
                ThumbnailView, Print, TextSearch, FormFields, FormDesigner, PageOrganizer
            ]}
        />
    </PdfViewerComponent>

    Set enableTextSelection to false

    Use the enableTextSelection during initialization to disable or enable text selection. The following example disables the text selection during initialization

  • TS
  • <PdfViewerComponent
        id="PdfViewer"
        ref={viewerRef}
        documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
        resourceUrl="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2-pdfviewer-lib"
        style={{ height: '100%' }}
        enableTextSelection={false}
    >
        <Inject
            services={[
                Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView,
                ThumbnailView, Print, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer
            ]}
        />
    </PdfViewerComponent>

    2. Toggle text selection at runtime

    The enableTextSelection property can also be used to toggle the text selection at runtime.

    import {
        PdfViewerComponent, Toolbar, Magnification, Navigation, LinkAnnotation, BookmarkView,
        ThumbnailView, Print, TextSelection, Annotation, TextSearch, FormFields, FormDesigner,
        PageOrganizer, Inject
    } from '@syncfusion/ej2-react-pdfviewer';
    import { useRef, RefObject } from 'react';
    
    export default function App() {
        const viewerRef: RefObject<PdfViewerComponent | null> = useRef<PdfViewerComponent>(null);
        const enableTextSelection = () => {
            if (viewerRef.current) {
                viewerRef.current.enableTextSelection = true;
            }
        }
        const disableTextSelection = () => {
            if (viewerRef.current) {
                viewerRef.current.enableTextSelection = false;
            }
        }
        return (
            <div style={{ height: '100vh' }}>
                <button onClick={enableTextSelection}>Enable Text Selection</button>
                <button onClick={disableTextSelection}>Disable Text Selection</button>
                <PdfViewerComponent
                    id="PdfViewer"
                    ref={viewerRef}
                    documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
                    resourceUrl="https://cdn.syncfusion.com/ej2/32.2.3/dist/ej2-pdfviewer-lib"
                    style={{ height: '100%' }}
                >
                    <Inject
                        services={[
                            Toolbar, Magnification, Navigation, Annotation, LinkAnnotation, BookmarkView,
                            ThumbnailView, Print, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer
                        ]}
                    />
                </PdfViewerComponent>
            </div>
        );
    }

    NOTE

    When text selection is disabled, the viewer automatically switches to pan mode.

    View sample in GitHub

    Use cases and considerations

    • Document protection: Disable text selection to help prevent copying sensitive content.
    • Read-only documents: Provide a cleaner viewing experience by preventing selection.
    • Interactive apps: Toggle selection based on user roles or document states.

    NOTE

    Text selection is enabled by default. Set enableTextSelection to false to disable it.

    Troubleshooting

    If text selection remains active, ensure that the TextSelection is removed in Inject or enableTextSelection is set to false.

    See also

Syncfusion AI Assistant

How can I help you?

Enable or Disable Text Selection in Syncfusion PDF Viewer

11 Feb 20263 minutes to read

The Syncfusion PDF Viewer exposes the enableTextSelection property to control whether users can select text within the displayed PDF document. This setting can be configured at initialization and toggled programmatically at runtime.

Configure text selection on initialization

Set the initial text-selection behavior by configuring the enableTextSelection property in the component template or on the PdfViewerComponent instance. The example below shows a complete component (TypeScript and template) that initializes the viewer with text selection disabled.

import { Component, OnInit, ViewChild } from '@angular/core';
import {
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  ToolbarService,
  NavigationService,
  AnnotationService,
  TextSearchService,
  TextSelectionService,
  FormFieldsService,
  FormDesignerService,
  PrintService,
  PdfViewerComponent
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div class="content-wrapper">
      <div class="button-container" style="margin-bottom: 10px;">
        <button (click)="enableTextSelection()" style="margin-right: 10px;">Enable Text Selection</button>
        <button (click)="disableTextSelection()">Disable Text Selection</button>
      </div>
      <ejs-pdfviewer
        #pdfViewer
        id="pdfViewer"
        [resourceUrl]="resourceUrl"
        [documentPath]="document"
        [enableTextSelection]="false"
        style="height: 640px; display: block;">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    ToolbarService,
    NavigationService,
    AnnotationService,
    TextSearchService,
    TextSelectionService,
    FormFieldsService,
    FormDesignerService,
    PrintService
  ]
})
export class AppComponent implements OnInit {
  public document: string = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resourceUrl: string = 'https://cdn.syncfusion.com/ej2/28.1.33/dist/ej2-pdfviewer-lib';

  @ViewChild('pdfViewer')
  public pdfViewerObj!: PdfViewerComponent;

  ngOnInit(): void { }
}

Toggle Text Selection Dynamically

To toggle text selection at runtime:

  1. Get a reference to the PdfViewerComponent using the @ViewChild decorator.
  2. Implement methods on the same component class to enable and disable text selection.
  3. Bind those methods to UI controls such as buttons.
<button (click)="enableTextSelection()" style="margin-right: 10px;">Enable Text Selection</button>
<button (click)="disableTextSelection()">Disable Text Selection</button>
// Enable text selection
enableTextSelection(): void {
  if (this.pdfViewerObj) {
    this.pdfViewerObj.enableTextSelection = true;
  }
}

// Disable text selection
disableTextSelection(): void {
  if (this.pdfViewerObj) {
    this.pdfViewerObj.enableTextSelection = false;
  }
}

Use Cases and Considerations

  • Document Protection: Disabling text selection helps prevent unauthorized copying of sensitive content.
  • Read-only Documents: In scenarios where documents are meant for viewing only, disabling text selection can provide a cleaner user experience.
  • Interactive Applications: Toggle text selection based on user roles or document states in complex applications.
  • Accessibility: Consider enabling text selection for accessibility purposes in public-facing applications.

Default Behavior

By default, text selection is enabled in the PDF Viewer. Set the enableTextSelection property to false explicitly if you want to disable this functionality.

View sample in GitHub

Syncfusion AI Assistant

How can I help you?

Enable or disable text selection in PDF Viewer

28 Feb 20265 minutes to read

The Syncfusion PDF Viewer exposes the enableTextSelection property to control whether users can select text within the displayed PDF document. This setting can be configured at initialization and toggled programmatically at runtime.

Configure text selection on initialization

Set the initial text-selection behavior by configuring the enableTextSelection property in the component template. The example below shows a complete component that initializes the viewer with text selection disabled.

<template>
  <div id="app">
    <ejs-pdfviewer
      id="pdfViewer"
      ref="pdfviewer"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :enableTextSelection="false"
      style="height: 640px;"
    >
    </ejs-pdfviewer>
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
} from '@syncfusion/ej2-vue-pdfviewer';
export default {
  name: 'App',
  components: {
    'ejs-pdfviewer': PdfViewerComponent,
  },
  data() {
    return {
        resourceUrl: "https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib",
        documentPath: "https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf",
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer,
    ],
  },
};
</script>

Toggle dynamically

To toggle text selection at runtime:

<template>
  <div id="app">
  <button @click="enableTextSelection" style="margin-bottom: 20px;">
      enableTextSelection
    </button>
    <button @click="disableTextSelection" style="margin-bottom: 20px;">
      disableTextSelection
    </button>
    <ejs-pdfviewer
      id="pdfViewer"
      ref="pdfviewer"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      :enableTextSelection="false"
      style="height: 640px;"
    >
    </ejs-pdfviewer>
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
} from '@syncfusion/ej2-vue-pdfviewer';
export default {
  name: 'App',
  components: {
    'ejs-pdfviewer': PdfViewerComponent,
  },
  data() {
    return {
        resourceUrl: "https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib",
        documentPath: "https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf",
    };
  },
  provide: {
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      Annotation,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer,
    ],
  },
  methods: {
    enableTextSelection() {
      var viewer = this.$refs.pdfviewer.ej2Instances;
      viewer.enableTextSelection = true;
    },
    disableTextSelection() {
      var viewer = this.$refs.pdfviewer.ej2Instances;
      viewer.enableTextSelection = false;
  },
  }
};
</script>

Use Cases and Considerations

  • Document protection: Disable text selection to help prevent copying sensitive content.
  • Read-only documents: Provide a cleaner viewing experience by preventing selection.
  • Interactive apps: Toggle selection based on user roles or document states.

Default Behavior

Text selection is enabled by default. Set enableTextSelection to false to disable it.

View Sample in GitHub